        LIST P=18F2550
        #INCLUDE <P18F2550.INC>





            UDATA
mulcnd      RES 1 ; 8 bit multiplicand
mulplr      RES 1 ; 8 bit multiplier
H_byte      RES 1 ; High byte of the 16 bit result
L_byte      RES 1 ; Low byte of the 16 bit result
count       RES 1 ; loop counter
speed       RES 1


Allocate     macro  name,size
name#v(0)sizeof EQU size
name#v(0)section  UDATA
name          RES size
             endm

#define SizeOf(var)  scnsz_low var#v(0)section
#define SizeOf_c(var)  var#v(0)sizeof

#define superupper(value) ((value>>D'24') & 0xFF) 

            Allocate test_variable, 1C
            Allocate buffer, 5E
            
BROJ EQU 0xEFFFFFFF
            
    
    GLOBAL mulcnd, mulplr, H_byte, L_byte


      CODE
mpy
    GLOBAL mpy
    
    clrf H_byte
    clrf L_byte
    movlw SizeOf(test_variable)
;    movlw  scnsz_low test_variable0section

    movwf count
    
 if SizeOf_c(test_variable) == 0x1C
    incf speed, F
    movlw  superupper(BROJ)
 else
    decf speed, F
    movlw  superupper(BROJ)
 endif    
    
    
    
    movlw 8
    movwf count
    movf mulcnd, W
    bcf STATUS, C ; Clear carry bit
loop rrncf mulplr, F
    btfsc STATUS, C
    addwf H_byte, F
    rrncf H_byte, F
    rrncf L_byte, F
    decfsz count, F
    goto loop
    retlw 0
    END